#if ! defined (WIN32)
#include <dlfcn.h>
#endif
#include <stdlib.h>
#include "pb.h"

int pb_load(pb_str_t *dir, pb_str_t *pfx, pb_str_t *bn, pb_str_t *ver,
    pb_sym_t *sym)
{
  pb_str_t *path;
#if defined (WIN32)
  int offs=_tcslen(dir->tcs)-1;
  HINSTANCE h;

  if (0==_tcscmp(_T("\\"),dir->tcs+offs)||0==_tcscmp(_T("/"),dir->tcs+offs)) {
    if (NULL==ver) {
      if (NULL==(path=pb_str_cat_ps(dir,bn,_PS(".dll"),NULL)))
        goto error;
    }
    else {
      if (NULL==(path=pb_str_cat_ps(dir,bn,_PS("-"),ver,_PS(".dll"),NULL)))
        goto error;
    }
  }
  else if (NULL==ver) {
    if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,bn,_PS(".dll"),NULL)))
      goto error;
  }
  else {
    if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,bn,_PS("-"),ver,
        _PS(".dll"),NULL))) {

      goto error;
    }
  }

  if (NULL==(h=LoadLibrary(PS_TCS(path)))) {
    _ftprintf(stderr,_T("Failed opening \"%s\": %d.\n"),PS_TCS(path),
        GetLastError());

    goto error;
  }

  while (NULL!=sym&&NULL!=sym->sym) {
    if (NULL==(*(void **)sym->ptr=(void *)GetProcAddress(h,sym->sym))) {
      fprintf(stderr,"Missing symbol \"%s\"",sym->sym);
      _ftprintf(stderr,_T(" in \"%s\".\n"),PS_TCS(path));
      goto error;
    }

    ++sym;
  }
#else
  void *h;

  if (NULL==pfx&&NULL==ver) {
    if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,bn,_PS(".so"),NULL)))
      goto error;
  }
  else if (NULL==ver) {
    if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,pfx,bn,_PS(".so"),NULL)))
      goto error;
  }
  else if (NULL==pfx) {
    if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,bn,_PS(".so."),ver,NULL)))
      goto error;
  }
  else if (NULL==(path=pb_str_cat_ps(dir,PS_SEP,pfx,bn,_PS(".so."),ver,NULL)))
    goto error;

  if (NULL==(h=dlopen(PS_UTF8(path),RTLD_LAZY))) {
    fprintf(stderr,"Failed opening \"%s\".\n",PS_UTF8(path));

    goto error;
  }

  while (NULL!=sym&&NULL!=sym->sym) {
    if (NULL==(*(void **)sym->ptr=dlsym(h,sym->sym))) {
      fprintf(stderr,"Missing symbol \"%s\" in \"%s\".\n",sym->sym,
          PS_UTF8(path));

      goto error;
    }

    ++sym;
  }
#endif
  free(path);

  return 0;
error:
  if (NULL!=path)
    free(path);

  return -1;
}
